From fb6263de967040b67636c4b55b202cf3bde6e34e Mon Sep 17 00:00:00 2001
From: Dominic Hargreaves <dom@earth.li>
Date: Sun, 27 Nov 2016 00:54:37 +0000
Subject: Adapt SMIME probe to work with openssl 1.1

OpenSSL 1.1 dropped the list-standard-commands command, so also try
'openssl list -commands'.

Forwarded: https://github.com/bestpractical/rt/pull/202
Patch-Name: openssl_1_1.diff
---
 lib/RT/Crypt/SMIME.pm | 8 ++++++++
 1 file changed, 8 insertions(+)

diff --git a/lib/RT/Crypt/SMIME.pm b/lib/RT/Crypt/SMIME.pm
index 3f764e9..57fc0c9 100644
--- a/lib/RT/Crypt/SMIME.pm
+++ b/lib/RT/Crypt/SMIME.pm
@@ -184,6 +184,14 @@ sub Probe {
             \$buf, \$err
         ) };
 
+        if ($err && $err =~ /Invalid command/) {
+            ($buf, $err) = ('', '');
+            safe_run_child { run3( [$bin, "list", "-commands"],
+                \undef,
+                \$buf, \$err
+            ) };
+        }
+
         if ($? or $err) {
             $RT::Logger->warning(
                 "RT's SMIME libraries couldn't successfully execute openssl.".
